Knox Docs Sign in

API reference

Test mode. Use your secret key on your server; live processing is currently disabled.

https://api.knoxapi.com

Send form-encoded requests with Authorization: Bearer sk_test_....

Complete OpenAPI specification · Integration guide

Operations and schemas are based on the pinned Stripe OpenAPI specification (MIT). Nested object definitions and enums are available in the complete specification.

GET /v1/charges

List all charges

Returns a list of charges you’ve previously created. The charges are returned in sorted order, with the most recent charges appearing first.

Request parameters

ParameterLocationTypeDescription
createdqueryone of multiple schemasOnly return charges that were created during the given date interval.
customerquerystringOnly return charges for the customer specified by this customer ID.
ending_beforequerystringA cursor for use in pagination. `ending_before` is an object ID that defines your place in the list. For instance, if you make a list request and receive 100 objects, starting with `obj_bar`, your subsequent call can include `ending_before=obj_bar` in order to fetch the previous page of the list.
expandqueryarray of stringSpecifies which fields in the response should be expanded.
limitqueryintegerA limit on the number of objects to be returned. Limit can range between 1 and 100, and the default is 10.
payment_intentquerystringOnly return charges that were created by the PaymentIntent specified by this PaymentIntent ID.
starting_afterquerystringA cursor for use in pagination. `starting_after` is an object ID that defines your place in the list. For instance, if you make a list request and receive 100 objects, ending with `obj_foo`, your subsequent call can include `starting_after=obj_foo` in order to fetch the next page of the list.
transfer_groupquerystringOnly return charges for this transfer group, limited to 100.

object. See the OpenAPI specification for the complete schema.

Responses

HTTP 200: Successful response.
FieldTypeDescription
data requiredarray of charge
has_more requiredbooleanTrue if this list has another page of items after this one that can be fetched.
object requiredstringString representing the object's type. Objects of the same type share the same value. Always has the value `list`.
url requiredstringThe URL where this list can be accessed.
HTTP default: Error response.
FieldTypeDescription
error requiredapi_errors
POST /v1/charges

Create a charge

This method is no longer recommended—use the Payment Intents API to initiate a new payment instead. Confirmation of the PaymentIntent creates the Charge object used to request payment.

Request parameters

FieldTypeDescription
amountintegerAmount intended to be collected by this payment. A positive integer representing how much to charge in the [smallest currency unit](https://docs.stripe.com/currencies#zero-decimal) (e.g., 100 cents to charge $1.00 or 100 to charge ¥100, a zero-decimal currency). The minimum amount is $0.50 US or [equivalent in charge currency](https://docs.stripe.com/currencies#minimum-and-maximum-charge-amounts). The amount value supports up to eight digits (e.g., a value of 99999999 for a USD charge of $999,999.99).
application_feeinteger
application_fee_amountintegerA fee in cents (or local equivalent) that will be applied to the charge and transferred to the application owner's Stripe account. The request must be made with an OAuth key or the `Stripe-Account` header in order to take an application fee. For more information, see the application fees [documentation](https://docs.stripe.com/connect/direct-charges#collect-fees).
capturebooleanWhether to immediately capture the charge. Defaults to `true`. When `false`, the charge issues an authorization (or pre-authorization), and will need to be [captured](https://api.stripe.com#capture_charge) later. Uncaptured charges expire after a set number of days (7 by default). For more information, see the [authorizing charges and settling later](https://docs.stripe.com/charges/placing-a-hold) documentation.
cardone of multiple schemasA token, like the ones returned by [Stripe.js](https://stripe.com/docs/js).
currencystringThree-letter [ISO currency code](https://www.iso.org/iso-4217-currency-codes.html), in lowercase. Must be a [supported currency](https://stripe.com/docs/currencies).
customerstringThe ID of an existing customer that will be charged in this request.
descriptionstringAn arbitrary string which you can attach to a `Charge` object. It is displayed when in the web interface alongside the charge. Note that if you use Stripe to send automatic email receipts to your customers, your receipt emails will include the `description` of the charge(s) that they are describing.
destinationone of multiple schemas
expandarray of stringSpecifies which fields in the response should be expanded.
metadataone of multiple schemasSet of [key-value pairs](https://docs.stripe.com/api/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to `metadata`.
on_behalf_ofstringThe Stripe account ID for which these funds are intended. You can specify the business of record as the connected account using the `on_behalf_of` attribute on the charge. For details, see [Creating Separate Charges and Transfers](https://docs.stripe.com/connect/separate-charges-and-transfers#settlement-merchant).
radar_optionsobjectOptions to configure Radar. See [Radar Session](https://docs.stripe.com/radar/radar-session) for more information.
receipt_emailstringThe email address to which this charge's [receipt](https://docs.stripe.com/dashboard/receipts) will be sent. The receipt will not be sent until the charge is paid, and no receipts will be sent for test mode charges. If this charge is for a [Customer](https://docs.stripe.com/api/customers/object), the email address specified here will override the customer's email address. If `receipt_email` is specified for a charge in live mode, a receipt will be sent regardless of your [email settings](https://dashboard.stripe.com/account/emails).
shippingobjectShipping information for the charge. Helps prevent fraud on charges for physical goods.
sourcestringA payment source to be charged. This can be the ID of a [card](https://docs.stripe.com/api#cards) (i.e., credit or debit card), a [bank account](https://docs.stripe.com/api#bank_accounts), a [source](https://docs.stripe.com/api#sources), a [token](https://docs.stripe.com/api#tokens), or a [connected account](https://docs.stripe.com/connect/account-debits#charging-a-connected-account). For certain sources---namely, [cards](https://docs.stripe.com/api#cards), [bank accounts](https://docs.stripe.com/api#bank_accounts), and attached [sources](https://docs.stripe.com/api#sources)---you must also pass the ID of the associated customer.
statement_descriptorstringFor a non-card charge, text that appears on the customer's statement as the statement descriptor. This value overrides the account's default statement descriptor. For information about requirements, including the 22-character limit, see [the Statement Descriptor docs](https://docs.stripe.com/get-started/account/statement-descriptors). For a card charge, this value is ignored unless you don't specify a `statement_descriptor_suffix`, in which case this value is used as the suffix.
statement_descriptor_suffixstringProvides information about a card charge. Concatenated to the account's [statement descriptor prefix](https://docs.stripe.com/get-started/account/statement-descriptors#static) to form the complete statement descriptor that appears on the customer's statement. If the account has no prefix value, the suffix is concatenated to the account's statement descriptor.
transfer_dataobjectAn optional dictionary including the account to automatically transfer to as part of a destination charge. [See the Connect documentation](https://docs.stripe.com/connect/destination-charges) for details.
transfer_groupstringA string that identifies this transaction as part of a group. For details, see [Grouping transactions](https://docs.stripe.com/connect/separate-charges-and-transfers#transfer-options).

Responses

HTTP 200: Successful response.
FieldTypeDescription
amount requiredintegerAmount intended to be collected by this payment. A positive integer representing how much to charge in the [smallest currency unit](https://docs.stripe.com/currencies#zero-decimal) (e.g., 100 cents to charge $1.00 or 100 to charge ¥100, a zero-decimal currency). The minimum amount is $0.50 US or [equivalent in charge currency](https://docs.stripe.com/currencies#minimum-and-maximum-charge-amounts). The amount value supports up to eight digits (e.g., a value of 99999999 for a USD charge of $999,999.99).
amount_captured requiredintegerAmount in cents (or local equivalent) captured (can be less than the amount attribute on the charge if a partial capture was made).
amount_refunded requiredintegerAmount in cents (or local equivalent) refunded (can be less than the amount attribute on the charge if a partial refund was issued).
applicationone of multiple schemasID of the Connect application that created the charge.
application_feeone of multiple schemasThe application fee (if any) for the charge. [See the Connect documentation](https://docs.stripe.com/connect/direct-charges#collect-fees) for details.
application_fee_amountintegerThe amount of the application fee (if any) requested for the charge. [See the Connect documentation](https://docs.stripe.com/connect/direct-charges#collect-fees) for details.
balance_transactionone of multiple schemasID of the balance transaction that describes the impact of this charge on your account balance (not including refunds or disputes).
billing_details requiredbilling_details
calculated_statement_descriptorstringThe full statement descriptor that is passed to card networks, and that is displayed on your customers' credit card and bank statements. Allows you to see what the statement descriptor looks like after the static and dynamic portions are combined. This value only exists for card payments.
captured requiredbooleanIf the charge was created without capturing, this Boolean represents whether it is still uncaptured or has since been captured.
created requiredintegerTime at which the object was created. Measured in seconds since the Unix epoch.
currency requiredstringThree-letter [ISO currency code](https://www.iso.org/iso-4217-currency-codes.html), in lowercase. Must be a [supported currency](https://stripe.com/docs/currencies).
customerone of multiple schemasID of the customer this charge is for if one exists.
descriptionstringAn arbitrary string attached to the object. Often useful for displaying to users.
disputed requiredbooleanWhether the charge has been disputed.
failure_balance_transactionone of multiple schemasID of the balance transaction that describes the reversal of the balance on your account due to payment failure.
failure_codestringError code explaining reason for charge failure if available (see [the errors section](https://docs.stripe.com/error-codes) for a list of codes).
failure_messagestringMessage to user further explaining reason for charge failure if available.
fraud_detailsone of multiple schemasInformation on fraud assessments for the charge.
id requiredstringUnique identifier for the object.
livemode requiredbooleanIf the object exists in live mode, the value is `true`. If the object exists in test mode, the value is `false`.
metadata requiredobjectSet of [key-value pairs](https://docs.stripe.com/api/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format.
object requiredstringString representing the object's type. Objects of the same type share the same value.
on_behalf_ofone of multiple schemasThe account (if any) the charge was made on behalf of without triggering an automatic transfer. See the [Connect documentation](https://docs.stripe.com/connect/separate-charges-and-transfers) for details.
outcomeone of multiple schemasDetails about whether the payment was accepted, and why. See [understanding declines](https://docs.stripe.com/declines) for details.
paid requiredboolean`true` if the charge succeeded, or was successfully authorized for later capture.
payment_intentone of multiple schemasID of the PaymentIntent associated with this charge, if one exists.
payment_methodstringID of the payment method used in this charge.
payment_method_detailsone of multiple schemasDetails about the payment method at the time of the transaction.
presentment_detailspayment_flows_payment_intent_presentment_details
radar_optionsradar_radar_options
receipt_emailstringThis is the email address that the receipt for this charge was sent to.
receipt_numberstringThis is the transaction number that appears on email receipts sent for this charge. This attribute will be `null` until a receipt has been sent.
receipt_urlstringThis is the URL to view the receipt for this charge. The receipt is kept up-to-date to the latest state of the charge, including any refunds. If the charge is for an Invoice, the receipt will be stylized as an Invoice receipt.
refunded requiredbooleanWhether the charge has been fully refunded. If the charge is only partially refunded, this attribute will still be false.
refundsobjectA list of refunds that have been applied to the charge.
reviewone of multiple schemasID of the review associated with this charge if one exists.
shippingone of multiple schemasShipping information for the charge.
source_transferone of multiple schemasThe transfer ID which created this charge. Only present if the charge came from another Stripe account. [See the Connect documentation](https://docs.stripe.com/connect/destination-charges) for details.
statement_descriptorstringFor a non-card charge, text that appears on the customer's statement as the statement descriptor. This value overrides the account's default statement descriptor. For information about requirements, including the 22-character limit, see [the Statement Descriptor docs](https://docs.stripe.com/get-started/account/statement-descriptors). For a card charge, this value is ignored unless you don't specify a `statement_descriptor_suffix`, in which case this value is used as the suffix.
statement_descriptor_suffixstringProvides information about a card charge. Concatenated to the account's [statement descriptor prefix](https://docs.stripe.com/get-started/account/statement-descriptors#static) to form the complete statement descriptor that appears on the customer's statement. If the account has no prefix value, the suffix is concatenated to the account's statement descriptor.
status requiredstringThe status of the payment is either `succeeded`, `pending`, or `failed`.
transferone of multiple schemasID of the transfer to the `destination` account (only applicable if the charge was created using the `destination` parameter).
transfer_dataone of multiple schemasAn optional dictionary including the account to automatically transfer to as part of a destination charge. [See the Connect documentation](https://docs.stripe.com/connect/destination-charges) for details.
transfer_groupstringA string that identifies this transaction as part of a group. See the [Connect documentation](https://docs.stripe.com/connect/separate-charges-and-transfers#transfer-options) for details.
HTTP default: Error response.
FieldTypeDescription
error requiredapi_errors
GET /v1/charges/search

Search charges

Search for charges you’ve previously created using Stripe’s Search Query Language. Don’t use search in read-after-write flows where strict consistency is necessary. Under normal operating conditions, data is searchable in less than a minute. Occasionally, propagation of new or updated data can be up to an hour behind during outages. Search functionality is not available to merchants in India.

Request parameters

ParameterLocationTypeDescription
expandqueryarray of stringSpecifies which fields in the response should be expanded.
limitqueryintegerA limit on the number of objects to be returned. Limit can range between 1 and 100, and the default is 10.
pagequerystringA cursor for pagination across multiple pages of results. Don't include this parameter on the first call. Use the next_page value returned in a previous response to request subsequent results.
queryquerystringThe search query string. See [search query language](https://docs.stripe.com/search#search-query-language) and the list of supported [query fields for charges](https://docs.stripe.com/search#query-fields-for-charges).

object. See the OpenAPI specification for the complete schema.

Responses

HTTP 200: Successful response.
FieldTypeDescription
data requiredarray of charge
has_more requiredboolean
next_pagestring
object requiredstringString representing the object's type. Objects of the same type share the same value.
total_countintegerThe total number of objects that match the query, only accurate up to 10,000.
url requiredstring
HTTP default: Error response.
FieldTypeDescription
error requiredapi_errors
GET /v1/charges/{charge}

Retrieve a charge

Retrieves the details of a charge that has previously been created. Supply the unique charge ID that was returned from your previous request, and Stripe will return the corresponding charge information. The same information is returned when creating or refunding the charge.

Request parameters

ParameterLocationTypeDescription
chargepathstring
expandqueryarray of stringSpecifies which fields in the response should be expanded.

object. See the OpenAPI specification for the complete schema.

Responses

HTTP 200: Successful response.
FieldTypeDescription
amount requiredintegerAmount intended to be collected by this payment. A positive integer representing how much to charge in the [smallest currency unit](https://docs.stripe.com/currencies#zero-decimal) (e.g., 100 cents to charge $1.00 or 100 to charge ¥100, a zero-decimal currency). The minimum amount is $0.50 US or [equivalent in charge currency](https://docs.stripe.com/currencies#minimum-and-maximum-charge-amounts). The amount value supports up to eight digits (e.g., a value of 99999999 for a USD charge of $999,999.99).
amount_captured requiredintegerAmount in cents (or local equivalent) captured (can be less than the amount attribute on the charge if a partial capture was made).
amount_refunded requiredintegerAmount in cents (or local equivalent) refunded (can be less than the amount attribute on the charge if a partial refund was issued).
applicationone of multiple schemasID of the Connect application that created the charge.
application_feeone of multiple schemasThe application fee (if any) for the charge. [See the Connect documentation](https://docs.stripe.com/connect/direct-charges#collect-fees) for details.
application_fee_amountintegerThe amount of the application fee (if any) requested for the charge. [See the Connect documentation](https://docs.stripe.com/connect/direct-charges#collect-fees) for details.
balance_transactionone of multiple schemasID of the balance transaction that describes the impact of this charge on your account balance (not including refunds or disputes).
billing_details requiredbilling_details
calculated_statement_descriptorstringThe full statement descriptor that is passed to card networks, and that is displayed on your customers' credit card and bank statements. Allows you to see what the statement descriptor looks like after the static and dynamic portions are combined. This value only exists for card payments.
captured requiredbooleanIf the charge was created without capturing, this Boolean represents whether it is still uncaptured or has since been captured.
created requiredintegerTime at which the object was created. Measured in seconds since the Unix epoch.
currency requiredstringThree-letter [ISO currency code](https://www.iso.org/iso-4217-currency-codes.html), in lowercase. Must be a [supported currency](https://stripe.com/docs/currencies).
customerone of multiple schemasID of the customer this charge is for if one exists.
descriptionstringAn arbitrary string attached to the object. Often useful for displaying to users.
disputed requiredbooleanWhether the charge has been disputed.
failure_balance_transactionone of multiple schemasID of the balance transaction that describes the reversal of the balance on your account due to payment failure.
failure_codestringError code explaining reason for charge failure if available (see [the errors section](https://docs.stripe.com/error-codes) for a list of codes).
failure_messagestringMessage to user further explaining reason for charge failure if available.
fraud_detailsone of multiple schemasInformation on fraud assessments for the charge.
id requiredstringUnique identifier for the object.
livemode requiredbooleanIf the object exists in live mode, the value is `true`. If the object exists in test mode, the value is `false`.
metadata requiredobjectSet of [key-value pairs](https://docs.stripe.com/api/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format.
object requiredstringString representing the object's type. Objects of the same type share the same value.
on_behalf_ofone of multiple schemasThe account (if any) the charge was made on behalf of without triggering an automatic transfer. See the [Connect documentation](https://docs.stripe.com/connect/separate-charges-and-transfers) for details.
outcomeone of multiple schemasDetails about whether the payment was accepted, and why. See [understanding declines](https://docs.stripe.com/declines) for details.
paid requiredboolean`true` if the charge succeeded, or was successfully authorized for later capture.
payment_intentone of multiple schemasID of the PaymentIntent associated with this charge, if one exists.
payment_methodstringID of the payment method used in this charge.
payment_method_detailsone of multiple schemasDetails about the payment method at the time of the transaction.
presentment_detailspayment_flows_payment_intent_presentment_details
radar_optionsradar_radar_options
receipt_emailstringThis is the email address that the receipt for this charge was sent to.
receipt_numberstringThis is the transaction number that appears on email receipts sent for this charge. This attribute will be `null` until a receipt has been sent.
receipt_urlstringThis is the URL to view the receipt for this charge. The receipt is kept up-to-date to the latest state of the charge, including any refunds. If the charge is for an Invoice, the receipt will be stylized as an Invoice receipt.
refunded requiredbooleanWhether the charge has been fully refunded. If the charge is only partially refunded, this attribute will still be false.
refundsobjectA list of refunds that have been applied to the charge.
reviewone of multiple schemasID of the review associated with this charge if one exists.
shippingone of multiple schemasShipping information for the charge.
source_transferone of multiple schemasThe transfer ID which created this charge. Only present if the charge came from another Stripe account. [See the Connect documentation](https://docs.stripe.com/connect/destination-charges) for details.
statement_descriptorstringFor a non-card charge, text that appears on the customer's statement as the statement descriptor. This value overrides the account's default statement descriptor. For information about requirements, including the 22-character limit, see [the Statement Descriptor docs](https://docs.stripe.com/get-started/account/statement-descriptors). For a card charge, this value is ignored unless you don't specify a `statement_descriptor_suffix`, in which case this value is used as the suffix.
statement_descriptor_suffixstringProvides information about a card charge. Concatenated to the account's [statement descriptor prefix](https://docs.stripe.com/get-started/account/statement-descriptors#static) to form the complete statement descriptor that appears on the customer's statement. If the account has no prefix value, the suffix is concatenated to the account's statement descriptor.
status requiredstringThe status of the payment is either `succeeded`, `pending`, or `failed`.
transferone of multiple schemasID of the transfer to the `destination` account (only applicable if the charge was created using the `destination` parameter).
transfer_dataone of multiple schemasAn optional dictionary including the account to automatically transfer to as part of a destination charge. [See the Connect documentation](https://docs.stripe.com/connect/destination-charges) for details.
transfer_groupstringA string that identifies this transaction as part of a group. See the [Connect documentation](https://docs.stripe.com/connect/separate-charges-and-transfers#transfer-options) for details.
HTTP default: Error response.
FieldTypeDescription
error requiredapi_errors
POST /v1/charges/{charge}

Update a charge

Updates the specified charge by setting the values of the parameters passed. Any parameters not provided will be left unchanged.

Request parameters

ParameterLocationTypeDescription
chargepathstring
FieldTypeDescription
customerstringThe ID of an existing customer that will be associated with this request. This field may only be updated if there is no existing associated customer with this charge.
descriptionstringAn arbitrary string which you can attach to a charge object. It is displayed when in the web interface alongside the charge. Note that if you use Stripe to send automatic email receipts to your customers, your receipt emails will include the `description` of the charge(s) that they are describing.
expandarray of stringSpecifies which fields in the response should be expanded.
fraud_detailsobjectA set of key-value pairs you can attach to a charge giving information about its riskiness. If you believe a charge is fraudulent, include a `user_report` key with a value of `fraudulent`. If you believe a charge is safe, include a `user_report` key with a value of `safe`. Stripe will use the information you send to improve our fraud detection algorithms.
metadataone of multiple schemasSet of [key-value pairs](https://docs.stripe.com/api/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to `metadata`.
receipt_emailstringThis is the email address that the receipt for this charge will be sent to. If this field is updated, then a new email receipt will be sent to the updated address.
shippingobjectShipping information for the charge. Helps prevent fraud on charges for physical goods.
transfer_groupstringA string that identifies this transaction as part of a group. `transfer_group` may only be provided if it has not been set. See the [Connect documentation](https://docs.stripe.com/connect/separate-charges-and-transfers#transfer-options) for details.

Responses

HTTP 200: Successful response.
FieldTypeDescription
amount requiredintegerAmount intended to be collected by this payment. A positive integer representing how much to charge in the [smallest currency unit](https://docs.stripe.com/currencies#zero-decimal) (e.g., 100 cents to charge $1.00 or 100 to charge ¥100, a zero-decimal currency). The minimum amount is $0.50 US or [equivalent in charge currency](https://docs.stripe.com/currencies#minimum-and-maximum-charge-amounts). The amount value supports up to eight digits (e.g., a value of 99999999 for a USD charge of $999,999.99).
amount_captured requiredintegerAmount in cents (or local equivalent) captured (can be less than the amount attribute on the charge if a partial capture was made).
amount_refunded requiredintegerAmount in cents (or local equivalent) refunded (can be less than the amount attribute on the charge if a partial refund was issued).
applicationone of multiple schemasID of the Connect application that created the charge.
application_feeone of multiple schemasThe application fee (if any) for the charge. [See the Connect documentation](https://docs.stripe.com/connect/direct-charges#collect-fees) for details.
application_fee_amountintegerThe amount of the application fee (if any) requested for the charge. [See the Connect documentation](https://docs.stripe.com/connect/direct-charges#collect-fees) for details.
balance_transactionone of multiple schemasID of the balance transaction that describes the impact of this charge on your account balance (not including refunds or disputes).
billing_details requiredbilling_details
calculated_statement_descriptorstringThe full statement descriptor that is passed to card networks, and that is displayed on your customers' credit card and bank statements. Allows you to see what the statement descriptor looks like after the static and dynamic portions are combined. This value only exists for card payments.
captured requiredbooleanIf the charge was created without capturing, this Boolean represents whether it is still uncaptured or has since been captured.
created requiredintegerTime at which the object was created. Measured in seconds since the Unix epoch.
currency requiredstringThree-letter [ISO currency code](https://www.iso.org/iso-4217-currency-codes.html), in lowercase. Must be a [supported currency](https://stripe.com/docs/currencies).
customerone of multiple schemasID of the customer this charge is for if one exists.
descriptionstringAn arbitrary string attached to the object. Often useful for displaying to users.
disputed requiredbooleanWhether the charge has been disputed.
failure_balance_transactionone of multiple schemasID of the balance transaction that describes the reversal of the balance on your account due to payment failure.
failure_codestringError code explaining reason for charge failure if available (see [the errors section](https://docs.stripe.com/error-codes) for a list of codes).
failure_messagestringMessage to user further explaining reason for charge failure if available.
fraud_detailsone of multiple schemasInformation on fraud assessments for the charge.
id requiredstringUnique identifier for the object.
livemode requiredbooleanIf the object exists in live mode, the value is `true`. If the object exists in test mode, the value is `false`.
metadata requiredobjectSet of [key-value pairs](https://docs.stripe.com/api/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format.
object requiredstringString representing the object's type. Objects of the same type share the same value.
on_behalf_ofone of multiple schemasThe account (if any) the charge was made on behalf of without triggering an automatic transfer. See the [Connect documentation](https://docs.stripe.com/connect/separate-charges-and-transfers) for details.
outcomeone of multiple schemasDetails about whether the payment was accepted, and why. See [understanding declines](https://docs.stripe.com/declines) for details.
paid requiredboolean`true` if the charge succeeded, or was successfully authorized for later capture.
payment_intentone of multiple schemasID of the PaymentIntent associated with this charge, if one exists.
payment_methodstringID of the payment method used in this charge.
payment_method_detailsone of multiple schemasDetails about the payment method at the time of the transaction.
presentment_detailspayment_flows_payment_intent_presentment_details
radar_optionsradar_radar_options
receipt_emailstringThis is the email address that the receipt for this charge was sent to.
receipt_numberstringThis is the transaction number that appears on email receipts sent for this charge. This attribute will be `null` until a receipt has been sent.
receipt_urlstringThis is the URL to view the receipt for this charge. The receipt is kept up-to-date to the latest state of the charge, including any refunds. If the charge is for an Invoice, the receipt will be stylized as an Invoice receipt.
refunded requiredbooleanWhether the charge has been fully refunded. If the charge is only partially refunded, this attribute will still be false.
refundsobjectA list of refunds that have been applied to the charge.
reviewone of multiple schemasID of the review associated with this charge if one exists.
shippingone of multiple schemasShipping information for the charge.
source_transferone of multiple schemasThe transfer ID which created this charge. Only present if the charge came from another Stripe account. [See the Connect documentation](https://docs.stripe.com/connect/destination-charges) for details.
statement_descriptorstringFor a non-card charge, text that appears on the customer's statement as the statement descriptor. This value overrides the account's default statement descriptor. For information about requirements, including the 22-character limit, see [the Statement Descriptor docs](https://docs.stripe.com/get-started/account/statement-descriptors). For a card charge, this value is ignored unless you don't specify a `statement_descriptor_suffix`, in which case this value is used as the suffix.
statement_descriptor_suffixstringProvides information about a card charge. Concatenated to the account's [statement descriptor prefix](https://docs.stripe.com/get-started/account/statement-descriptors#static) to form the complete statement descriptor that appears on the customer's statement. If the account has no prefix value, the suffix is concatenated to the account's statement descriptor.
status requiredstringThe status of the payment is either `succeeded`, `pending`, or `failed`.
transferone of multiple schemasID of the transfer to the `destination` account (only applicable if the charge was created using the `destination` parameter).
transfer_dataone of multiple schemasAn optional dictionary including the account to automatically transfer to as part of a destination charge. [See the Connect documentation](https://docs.stripe.com/connect/destination-charges) for details.
transfer_groupstringA string that identifies this transaction as part of a group. See the [Connect documentation](https://docs.stripe.com/connect/separate-charges-and-transfers#transfer-options) for details.
HTTP default: Error response.
FieldTypeDescription
error requiredapi_errors
POST /v1/charges/{charge}/capture

Capture a charge

Capture the payment of an existing, uncaptured charge that was created with the capture option set to false. Uncaptured payments expire a set number of days after they are created (7 by default), after which they are marked as refunded and capture attempts will fail. Don’t use this method to capture a PaymentIntent-initiated charge. Use Capture a PaymentIntent.

Request parameters

ParameterLocationTypeDescription
chargepathstring
FieldTypeDescription
amountintegerThe amount to capture, which must be less than or equal to the original amount.
application_feeintegerAn application fee to add on to this charge.
application_fee_amountintegerAn application fee amount to add on to this charge, which must be less than or equal to the original amount.
expandarray of stringSpecifies which fields in the response should be expanded.
receipt_emailstringThe email address to send this charge's receipt to. This will override the previously-specified email address for this charge, if one was set. Receipts will not be sent in test mode.
statement_descriptorstringFor a non-card charge, text that appears on the customer's statement as the statement descriptor. This value overrides the account's default statement descriptor. For information about requirements, including the 22-character limit, see [the Statement Descriptor docs](https://docs.stripe.com/get-started/account/statement-descriptors). For a card charge, this value is ignored unless you don't specify a `statement_descriptor_suffix`, in which case this value is used as the suffix.
statement_descriptor_suffixstringProvides information about a card charge. Concatenated to the account's [statement descriptor prefix](https://docs.stripe.com/get-started/account/statement-descriptors#static) to form the complete statement descriptor that appears on the customer's statement. If the account has no prefix value, the suffix is concatenated to the account's statement descriptor.
transfer_dataobjectAn optional dictionary including the account to automatically transfer to as part of a destination charge. [See the Connect documentation](https://docs.stripe.com/connect/destination-charges) for details.
transfer_groupstringA string that identifies this transaction as part of a group. `transfer_group` may only be provided if it has not been set. See the [Connect documentation](https://docs.stripe.com/connect/separate-charges-and-transfers#transfer-options) for details.

Responses

HTTP 200: Successful response.
FieldTypeDescription
amount requiredintegerAmount intended to be collected by this payment. A positive integer representing how much to charge in the [smallest currency unit](https://docs.stripe.com/currencies#zero-decimal) (e.g., 100 cents to charge $1.00 or 100 to charge ¥100, a zero-decimal currency). The minimum amount is $0.50 US or [equivalent in charge currency](https://docs.stripe.com/currencies#minimum-and-maximum-charge-amounts). The amount value supports up to eight digits (e.g., a value of 99999999 for a USD charge of $999,999.99).
amount_captured requiredintegerAmount in cents (or local equivalent) captured (can be less than the amount attribute on the charge if a partial capture was made).
amount_refunded requiredintegerAmount in cents (or local equivalent) refunded (can be less than the amount attribute on the charge if a partial refund was issued).
applicationone of multiple schemasID of the Connect application that created the charge.
application_feeone of multiple schemasThe application fee (if any) for the charge. [See the Connect documentation](https://docs.stripe.com/connect/direct-charges#collect-fees) for details.
application_fee_amountintegerThe amount of the application fee (if any) requested for the charge. [See the Connect documentation](https://docs.stripe.com/connect/direct-charges#collect-fees) for details.
balance_transactionone of multiple schemasID of the balance transaction that describes the impact of this charge on your account balance (not including refunds or disputes).
billing_details requiredbilling_details
calculated_statement_descriptorstringThe full statement descriptor that is passed to card networks, and that is displayed on your customers' credit card and bank statements. Allows you to see what the statement descriptor looks like after the static and dynamic portions are combined. This value only exists for card payments.
captured requiredbooleanIf the charge was created without capturing, this Boolean represents whether it is still uncaptured or has since been captured.
created requiredintegerTime at which the object was created. Measured in seconds since the Unix epoch.
currency requiredstringThree-letter [ISO currency code](https://www.iso.org/iso-4217-currency-codes.html), in lowercase. Must be a [supported currency](https://stripe.com/docs/currencies).
customerone of multiple schemasID of the customer this charge is for if one exists.
descriptionstringAn arbitrary string attached to the object. Often useful for displaying to users.
disputed requiredbooleanWhether the charge has been disputed.
failure_balance_transactionone of multiple schemasID of the balance transaction that describes the reversal of the balance on your account due to payment failure.
failure_codestringError code explaining reason for charge failure if available (see [the errors section](https://docs.stripe.com/error-codes) for a list of codes).
failure_messagestringMessage to user further explaining reason for charge failure if available.
fraud_detailsone of multiple schemasInformation on fraud assessments for the charge.
id requiredstringUnique identifier for the object.
livemode requiredbooleanIf the object exists in live mode, the value is `true`. If the object exists in test mode, the value is `false`.
metadata requiredobjectSet of [key-value pairs](https://docs.stripe.com/api/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format.
object requiredstringString representing the object's type. Objects of the same type share the same value.
on_behalf_ofone of multiple schemasThe account (if any) the charge was made on behalf of without triggering an automatic transfer. See the [Connect documentation](https://docs.stripe.com/connect/separate-charges-and-transfers) for details.
outcomeone of multiple schemasDetails about whether the payment was accepted, and why. See [understanding declines](https://docs.stripe.com/declines) for details.
paid requiredboolean`true` if the charge succeeded, or was successfully authorized for later capture.
payment_intentone of multiple schemasID of the PaymentIntent associated with this charge, if one exists.
payment_methodstringID of the payment method used in this charge.
payment_method_detailsone of multiple schemasDetails about the payment method at the time of the transaction.
presentment_detailspayment_flows_payment_intent_presentment_details
radar_optionsradar_radar_options
receipt_emailstringThis is the email address that the receipt for this charge was sent to.
receipt_numberstringThis is the transaction number that appears on email receipts sent for this charge. This attribute will be `null` until a receipt has been sent.
receipt_urlstringThis is the URL to view the receipt for this charge. The receipt is kept up-to-date to the latest state of the charge, including any refunds. If the charge is for an Invoice, the receipt will be stylized as an Invoice receipt.
refunded requiredbooleanWhether the charge has been fully refunded. If the charge is only partially refunded, this attribute will still be false.
refundsobjectA list of refunds that have been applied to the charge.
reviewone of multiple schemasID of the review associated with this charge if one exists.
shippingone of multiple schemasShipping information for the charge.
source_transferone of multiple schemasThe transfer ID which created this charge. Only present if the charge came from another Stripe account. [See the Connect documentation](https://docs.stripe.com/connect/destination-charges) for details.
statement_descriptorstringFor a non-card charge, text that appears on the customer's statement as the statement descriptor. This value overrides the account's default statement descriptor. For information about requirements, including the 22-character limit, see [the Statement Descriptor docs](https://docs.stripe.com/get-started/account/statement-descriptors). For a card charge, this value is ignored unless you don't specify a `statement_descriptor_suffix`, in which case this value is used as the suffix.
statement_descriptor_suffixstringProvides information about a card charge. Concatenated to the account's [statement descriptor prefix](https://docs.stripe.com/get-started/account/statement-descriptors#static) to form the complete statement descriptor that appears on the customer's statement. If the account has no prefix value, the suffix is concatenated to the account's statement descriptor.
status requiredstringThe status of the payment is either `succeeded`, `pending`, or `failed`.
transferone of multiple schemasID of the transfer to the `destination` account (only applicable if the charge was created using the `destination` parameter).
transfer_dataone of multiple schemasAn optional dictionary including the account to automatically transfer to as part of a destination charge. [See the Connect documentation](https://docs.stripe.com/connect/destination-charges) for details.
transfer_groupstringA string that identifies this transaction as part of a group. See the [Connect documentation](https://docs.stripe.com/connect/separate-charges-and-transfers#transfer-options) for details.
HTTP default: Error response.
FieldTypeDescription
error requiredapi_errors
GET /v1/charges/{charge}/dispute

/v1/charges/{charge}/dispute

Retrieve a dispute for a specified charge.

Request parameters

ParameterLocationTypeDescription
chargepathstring
expandqueryarray of stringSpecifies which fields in the response should be expanded.

object. See the OpenAPI specification for the complete schema.

Responses

HTTP 200: Successful response.
FieldTypeDescription
amount requiredintegerDisputed amount. Usually the amount of the charge, but it can differ (usually because of currency fluctuation or because only part of the order is disputed).
balance_transactions requiredarray of balance_transactionList of zero, one, or two balance transactions that show funds withdrawn and reinstated to your Stripe account as a result of this dispute.
charge requiredone of multiple schemasID of the charge that's disputed.
created requiredintegerTime at which the object was created. Measured in seconds since the Unix epoch.
currency requiredstringThree-letter [ISO currency code](https://www.iso.org/iso-4217-currency-codes.html), in lowercase. Must be a [supported currency](https://stripe.com/docs/currencies).
enhanced_eligibility_types requiredarray of stringList of eligibility types that are included in `enhanced_evidence`.
evidence requireddispute_evidence
evidence_details requireddispute_evidence_details
id requiredstringUnique identifier for the object.
is_charge_refundable requiredbooleanIf true, it's still possible to refund the disputed payment. After the payment has been fully refunded, no further funds are withdrawn from your Stripe account as a result of this dispute.
livemode requiredbooleanIf the object exists in live mode, the value is `true`. If the object exists in test mode, the value is `false`.
metadata requiredobjectSet of [key-value pairs](https://docs.stripe.com/api/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format.
object requiredstringString representing the object's type. Objects of the same type share the same value.
payment_intentone of multiple schemasID of the PaymentIntent that's disputed.
payment_method_detailsdispute_payment_method_details
reason requiredstringReason given by cardholder for dispute. Possible values are `bank_cannot_process`, `check_returned`, `credit_not_processed`, `customer_initiated`, `debit_not_authorized`, `duplicate`, `fraudulent`, `general`, `incorrect_account_details`, `insufficient_funds`, `noncompliant`, `product_not_received`, `product_unacceptable`, `subscription_canceled`, or `unrecognized`. Learn more about [dispute reasons](https://docs.stripe.com/disputes/categories).
status requiredstringThe current status of a dispute. Possible values include:`warning_needs_response`, `warning_under_review`, `warning_closed`, `needs_response`, `under_review`, `won`, `lost`, or `prevented`.
HTTP default: Error response.
FieldTypeDescription
error requiredapi_errors
POST /v1/charges/{charge}/dispute

/v1/charges/{charge}/dispute

Request parameters

ParameterLocationTypeDescription
chargepathstring
FieldTypeDescription
evidenceobjectEvidence to upload, to respond to a dispute. Updating any field in the hash will submit all fields in the hash for review. The combined character count of all fields is limited to 150,000.
expandarray of stringSpecifies which fields in the response should be expanded.
metadataone of multiple schemasSet of [key-value pairs](https://docs.stripe.com/api/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to `metadata`.
submitbooleanWhether to immediately submit evidence to the bank. If `false`, evidence is staged on the dispute. Staged evidence is visible in the API and Dashboard, and can be submitted to the bank by making another request with this attribute set to `true` (the default).

Responses

HTTP 200: Successful response.
FieldTypeDescription
amount requiredintegerDisputed amount. Usually the amount of the charge, but it can differ (usually because of currency fluctuation or because only part of the order is disputed).
balance_transactions requiredarray of balance_transactionList of zero, one, or two balance transactions that show funds withdrawn and reinstated to your Stripe account as a result of this dispute.
charge requiredone of multiple schemasID of the charge that's disputed.
created requiredintegerTime at which the object was created. Measured in seconds since the Unix epoch.
currency requiredstringThree-letter [ISO currency code](https://www.iso.org/iso-4217-currency-codes.html), in lowercase. Must be a [supported currency](https://stripe.com/docs/currencies).
enhanced_eligibility_types requiredarray of stringList of eligibility types that are included in `enhanced_evidence`.
evidence requireddispute_evidence
evidence_details requireddispute_evidence_details
id requiredstringUnique identifier for the object.
is_charge_refundable requiredbooleanIf true, it's still possible to refund the disputed payment. After the payment has been fully refunded, no further funds are withdrawn from your Stripe account as a result of this dispute.
livemode requiredbooleanIf the object exists in live mode, the value is `true`. If the object exists in test mode, the value is `false`.
metadata requiredobjectSet of [key-value pairs](https://docs.stripe.com/api/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format.
object requiredstringString representing the object's type. Objects of the same type share the same value.
payment_intentone of multiple schemasID of the PaymentIntent that's disputed.
payment_method_detailsdispute_payment_method_details
reason requiredstringReason given by cardholder for dispute. Possible values are `bank_cannot_process`, `check_returned`, `credit_not_processed`, `customer_initiated`, `debit_not_authorized`, `duplicate`, `fraudulent`, `general`, `incorrect_account_details`, `insufficient_funds`, `noncompliant`, `product_not_received`, `product_unacceptable`, `subscription_canceled`, or `unrecognized`. Learn more about [dispute reasons](https://docs.stripe.com/disputes/categories).
status requiredstringThe current status of a dispute. Possible values include:`warning_needs_response`, `warning_under_review`, `warning_closed`, `needs_response`, `under_review`, `won`, `lost`, or `prevented`.
HTTP default: Error response.
FieldTypeDescription
error requiredapi_errors
POST /v1/charges/{charge}/dispute/close

/v1/charges/{charge}/dispute/close

Request parameters

ParameterLocationTypeDescription
chargepathstring
FieldTypeDescription
expandarray of stringSpecifies which fields in the response should be expanded.

Responses

HTTP 200: Successful response.
FieldTypeDescription
amount requiredintegerDisputed amount. Usually the amount of the charge, but it can differ (usually because of currency fluctuation or because only part of the order is disputed).
balance_transactions requiredarray of balance_transactionList of zero, one, or two balance transactions that show funds withdrawn and reinstated to your Stripe account as a result of this dispute.
charge requiredone of multiple schemasID of the charge that's disputed.
created requiredintegerTime at which the object was created. Measured in seconds since the Unix epoch.
currency requiredstringThree-letter [ISO currency code](https://www.iso.org/iso-4217-currency-codes.html), in lowercase. Must be a [supported currency](https://stripe.com/docs/currencies).
enhanced_eligibility_types requiredarray of stringList of eligibility types that are included in `enhanced_evidence`.
evidence requireddispute_evidence
evidence_details requireddispute_evidence_details
id requiredstringUnique identifier for the object.
is_charge_refundable requiredbooleanIf true, it's still possible to refund the disputed payment. After the payment has been fully refunded, no further funds are withdrawn from your Stripe account as a result of this dispute.
livemode requiredbooleanIf the object exists in live mode, the value is `true`. If the object exists in test mode, the value is `false`.
metadata requiredobjectSet of [key-value pairs](https://docs.stripe.com/api/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format.
object requiredstringString representing the object's type. Objects of the same type share the same value.
payment_intentone of multiple schemasID of the PaymentIntent that's disputed.
payment_method_detailsdispute_payment_method_details
reason requiredstringReason given by cardholder for dispute. Possible values are `bank_cannot_process`, `check_returned`, `credit_not_processed`, `customer_initiated`, `debit_not_authorized`, `duplicate`, `fraudulent`, `general`, `incorrect_account_details`, `insufficient_funds`, `noncompliant`, `product_not_received`, `product_unacceptable`, `subscription_canceled`, or `unrecognized`. Learn more about [dispute reasons](https://docs.stripe.com/disputes/categories).
status requiredstringThe current status of a dispute. Possible values include:`warning_needs_response`, `warning_under_review`, `warning_closed`, `needs_response`, `under_review`, `won`, `lost`, or `prevented`.
HTTP default: Error response.
FieldTypeDescription
error requiredapi_errors
POST /v1/charges/{charge}/refund

Create a refund

When you create a new refund, you must specify either a Charge or a PaymentIntent object. This action refunds a previously created charge that’s not refunded yet. Funds are refunded to the credit or debit card that’s originally charged. You can optionally refund only part of a charge. You can repeat this until the entire charge is refunded. After you entirely refund a charge, you can’t refund it again. This method raises an error when it’s called on an already-refunded charge, or when you attempt to refund more money than is left on a charge.

Request parameters

ParameterLocationTypeDescription
chargepathstringThe identifier of the charge to refund.
FieldTypeDescription
amountintegerA positive integer in the [smallest currency unit](https://docs.stripe.com/currencies#zero-decimal) representing how much of this charge to refund. Can refund only up to the remaining, unrefunded amount of the charge.
expandarray of stringSpecifies which fields in the response should be expanded.
instructions_emailstringFor payment methods without native refund support (e.g., Konbini, PromptPay), use this email from the customer to receive refund instructions.
metadataone of multiple schemasSet of [key-value pairs](https://docs.stripe.com/api/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to `metadata`.
payment_intentstringThe identifier of the PaymentIntent to refund.
reasonstringString indicating the reason for the refund. If set, possible values are `duplicate`, `fraudulent`, and `requested_by_customer`. If you believe the charge to be fraudulent, specifying `fraudulent` as the reason will add the associated card and email to your [block lists](https://docs.stripe.com/radar/lists), and will also help us improve our fraud detection algorithms.
refund_application_feebooleanBoolean indicating whether the application fee should be refunded when refunding this charge. If a full charge refund is given, the full application fee will be refunded. Otherwise, the application fee will be refunded in an amount proportional to the amount of the charge refunded. An application fee can be refunded only by the application that created the charge.
reverse_transferbooleanBoolean indicating whether the transfer should be reversed when refunding this charge. The transfer will be reversed proportionally to the amount being refunded (either the entire or partial amount).A transfer can be reversed only by the application that created the charge.

Responses

HTTP 200: Successful response.
FieldTypeDescription
amount requiredintegerAmount intended to be collected by this payment. A positive integer representing how much to charge in the [smallest currency unit](https://docs.stripe.com/currencies#zero-decimal) (e.g., 100 cents to charge $1.00 or 100 to charge ¥100, a zero-decimal currency). The minimum amount is $0.50 US or [equivalent in charge currency](https://docs.stripe.com/currencies#minimum-and-maximum-charge-amounts). The amount value supports up to eight digits (e.g., a value of 99999999 for a USD charge of $999,999.99).
amount_captured requiredintegerAmount in cents (or local equivalent) captured (can be less than the amount attribute on the charge if a partial capture was made).
amount_refunded requiredintegerAmount in cents (or local equivalent) refunded (can be less than the amount attribute on the charge if a partial refund was issued).
applicationone of multiple schemasID of the Connect application that created the charge.
application_feeone of multiple schemasThe application fee (if any) for the charge. [See the Connect documentation](https://docs.stripe.com/connect/direct-charges#collect-fees) for details.
application_fee_amountintegerThe amount of the application fee (if any) requested for the charge. [See the Connect documentation](https://docs.stripe.com/connect/direct-charges#collect-fees) for details.
balance_transactionone of multiple schemasID of the balance transaction that describes the impact of this charge on your account balance (not including refunds or disputes).
billing_details requiredbilling_details
calculated_statement_descriptorstringThe full statement descriptor that is passed to card networks, and that is displayed on your customers' credit card and bank statements. Allows you to see what the statement descriptor looks like after the static and dynamic portions are combined. This value only exists for card payments.
captured requiredbooleanIf the charge was created without capturing, this Boolean represents whether it is still uncaptured or has since been captured.
created requiredintegerTime at which the object was created. Measured in seconds since the Unix epoch.
currency requiredstringThree-letter [ISO currency code](https://www.iso.org/iso-4217-currency-codes.html), in lowercase. Must be a [supported currency](https://stripe.com/docs/currencies).
customerone of multiple schemasID of the customer this charge is for if one exists.
descriptionstringAn arbitrary string attached to the object. Often useful for displaying to users.
disputed requiredbooleanWhether the charge has been disputed.
failure_balance_transactionone of multiple schemasID of the balance transaction that describes the reversal of the balance on your account due to payment failure.
failure_codestringError code explaining reason for charge failure if available (see [the errors section](https://docs.stripe.com/error-codes) for a list of codes).
failure_messagestringMessage to user further explaining reason for charge failure if available.
fraud_detailsone of multiple schemasInformation on fraud assessments for the charge.
id requiredstringUnique identifier for the object.
livemode requiredbooleanIf the object exists in live mode, the value is `true`. If the object exists in test mode, the value is `false`.
metadata requiredobjectSet of [key-value pairs](https://docs.stripe.com/api/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format.
object requiredstringString representing the object's type. Objects of the same type share the same value.
on_behalf_ofone of multiple schemasThe account (if any) the charge was made on behalf of without triggering an automatic transfer. See the [Connect documentation](https://docs.stripe.com/connect/separate-charges-and-transfers) for details.
outcomeone of multiple schemasDetails about whether the payment was accepted, and why. See [understanding declines](https://docs.stripe.com/declines) for details.
paid requiredboolean`true` if the charge succeeded, or was successfully authorized for later capture.
payment_intentone of multiple schemasID of the PaymentIntent associated with this charge, if one exists.
payment_methodstringID of the payment method used in this charge.
payment_method_detailsone of multiple schemasDetails about the payment method at the time of the transaction.
presentment_detailspayment_flows_payment_intent_presentment_details
radar_optionsradar_radar_options
receipt_emailstringThis is the email address that the receipt for this charge was sent to.
receipt_numberstringThis is the transaction number that appears on email receipts sent for this charge. This attribute will be `null` until a receipt has been sent.
receipt_urlstringThis is the URL to view the receipt for this charge. The receipt is kept up-to-date to the latest state of the charge, including any refunds. If the charge is for an Invoice, the receipt will be stylized as an Invoice receipt.
refunded requiredbooleanWhether the charge has been fully refunded. If the charge is only partially refunded, this attribute will still be false.
refundsobjectA list of refunds that have been applied to the charge.
reviewone of multiple schemasID of the review associated with this charge if one exists.
shippingone of multiple schemasShipping information for the charge.
source_transferone of multiple schemasThe transfer ID which created this charge. Only present if the charge came from another Stripe account. [See the Connect documentation](https://docs.stripe.com/connect/destination-charges) for details.
statement_descriptorstringFor a non-card charge, text that appears on the customer's statement as the statement descriptor. This value overrides the account's default statement descriptor. For information about requirements, including the 22-character limit, see [the Statement Descriptor docs](https://docs.stripe.com/get-started/account/statement-descriptors). For a card charge, this value is ignored unless you don't specify a `statement_descriptor_suffix`, in which case this value is used as the suffix.
statement_descriptor_suffixstringProvides information about a card charge. Concatenated to the account's [statement descriptor prefix](https://docs.stripe.com/get-started/account/statement-descriptors#static) to form the complete statement descriptor that appears on the customer's statement. If the account has no prefix value, the suffix is concatenated to the account's statement descriptor.
status requiredstringThe status of the payment is either `succeeded`, `pending`, or `failed`.
transferone of multiple schemasID of the transfer to the `destination` account (only applicable if the charge was created using the `destination` parameter).
transfer_dataone of multiple schemasAn optional dictionary including the account to automatically transfer to as part of a destination charge. [See the Connect documentation](https://docs.stripe.com/connect/destination-charges) for details.
transfer_groupstringA string that identifies this transaction as part of a group. See the [Connect documentation](https://docs.stripe.com/connect/separate-charges-and-transfers#transfer-options) for details.
HTTP default: Error response.
FieldTypeDescription
error requiredapi_errors
GET /v1/charges/{charge}/refunds

List all refunds

You can see a list of the refunds belonging to a specific charge. Note that the 10 most recent refunds are always available by default on the charge object. If you need more than those 10, you can use this API method and the limit and starting_after parameters to page through additional refunds.

Request parameters

ParameterLocationTypeDescription
chargepathstring
ending_beforequerystringA cursor for use in pagination. `ending_before` is an object ID that defines your place in the list. For instance, if you make a list request and receive 100 objects, starting with `obj_bar`, your subsequent call can include `ending_before=obj_bar` in order to fetch the previous page of the list.
expandqueryarray of stringSpecifies which fields in the response should be expanded.
limitqueryintegerA limit on the number of objects to be returned. Limit can range between 1 and 100, and the default is 10.
starting_afterquerystringA cursor for use in pagination. `starting_after` is an object ID that defines your place in the list. For instance, if you make a list request and receive 100 objects, ending with `obj_foo`, your subsequent call can include `starting_after=obj_foo` in order to fetch the next page of the list.

object. See the OpenAPI specification for the complete schema.

Responses

HTTP 200: Successful response.
FieldTypeDescription
data requiredarray of refundDetails about each object.
has_more requiredbooleanTrue if this list has another page of items after this one that can be fetched.
object requiredstringString representing the object's type. Objects of the same type share the same value. Always has the value `list`.
url requiredstringThe URL where this list can be accessed.
HTTP default: Error response.
FieldTypeDescription
error requiredapi_errors
POST /v1/charges/{charge}/refunds

Create a refund

When you create a new refund, you must specify a Charge or a PaymentIntent object on which to create it. Creating a new refund will refund a charge that has previously been created but not yet refunded. Funds will be refunded to the credit or debit card that was originally charged. You can optionally refund only part of a charge. You can do so multiple times, until the entire charge has been refunded. Once entirely refunded, a charge can’t be refunded again. This method will raise an error when called on an already-refunded charge, or when trying to refund more money than is left on a charge.

Request parameters

ParameterLocationTypeDescription
chargepathstringThe identifier of the charge to refund.
FieldTypeDescription
amountinteger
currencystringThree-letter [ISO currency code](https://www.iso.org/iso-4217-currency-codes.html), in lowercase. Must be a [supported currency](https://stripe.com/docs/currencies).
customerstringCustomer whose customer balance to refund from.
expandarray of stringSpecifies which fields in the response should be expanded.
instructions_emailstringFor payment methods without native refund support (e.g., Konbini, PromptPay), use this email from the customer to receive refund instructions.
metadataone of multiple schemasSet of [key-value pairs](https://docs.stripe.com/api/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to `metadata`.
originstringOrigin of the refund
payment_intentstringThe identifier of the PaymentIntent to refund.
reasonstringString indicating the reason for the refund. If set, possible values are `duplicate`, `fraudulent`, and `requested_by_customer`. If you believe the charge to be fraudulent, specifying `fraudulent` as the reason will add the associated card and email to your [block lists](https://docs.stripe.com/radar/lists), and will also help us improve our fraud detection algorithms.
refund_application_feebooleanBoolean indicating whether the application fee should be refunded when refunding this charge. If a full charge refund is given, the full application fee will be refunded. Otherwise, the application fee will be refunded in an amount proportional to the amount of the charge refunded. An application fee can be refunded only by the application that created the charge.
reverse_transferbooleanBoolean indicating whether the transfer should be reversed when refunding this charge. The transfer will be reversed proportionally to the amount being refunded (either the entire or partial amount).A transfer can be reversed only by the application that created the charge.

Responses

HTTP 200: Successful response.
FieldTypeDescription
amount requiredintegerAmount, in cents (or local equivalent).
balance_transactionone of multiple schemasBalance transaction that describes the impact on your account balance.
chargeone of multiple schemasID of the charge that's refunded.
created requiredintegerTime at which the object was created. Measured in seconds since the Unix epoch.
currency requiredstringThree-letter [ISO currency code](https://www.iso.org/iso-4217-currency-codes.html), in lowercase. Must be a [supported currency](https://stripe.com/docs/currencies).
customerone of multiple schemasID of the customer of this refund.
customer_accountstringID of the account of this refund.
descriptionstringAn arbitrary string attached to the object. You can use this for displaying to users (available on non-card refunds only).
destination_detailsrefund_destination_details
failure_balance_transactionone of multiple schemasAfter the refund fails, this balance transaction describes the adjustment made on your account balance that reverses the initial balance transaction.
failure_reasonstringProvides the reason for the refund failure. Possible values are: `lost_or_stolen_card`, `expired_or_canceled_card`, `charge_for_pending_refund_disputed`, `insufficient_funds`, `declined`, `merchant_request`, or `unknown`.
id requiredstringUnique identifier for the object.
instructions_emailstringFor payment methods without native refund support (for example, Konbini, PromptPay), provide an email address for the customer to receive refund instructions.
metadataobjectSet of [key-value pairs](https://docs.stripe.com/api/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format.
next_actionrefund_next_action
object requiredstringString representing the object's type. Objects of the same type share the same value.
payment_intentone of multiple schemasID of the PaymentIntent that's refunded.
payment_methodone of multiple schemasID of the payment method associated with this refund.
pending_reasonstringProvides the reason for why the refund is pending. Possible values are: `processing`, `insufficient_funds`, or `charge_pending`.
presentment_detailspayment_flows_payment_intent_presentment_details
reasonstringReason for the refund, which is either user-provided (`duplicate`, `fraudulent`, or `requested_by_customer`) or generated by Stripe internally (`expired_uncaptured_charge`).
receipt_numberstringThis is the transaction number that appears on email receipts sent for this refund.
source_transfer_reversalone of multiple schemasThe transfer reversal that's associated with the refund. Only present if the charge came from another Stripe account.
statusstringStatus of the refund. This can be `pending`, `requires_action`, `succeeded`, `failed`, or `canceled`. Learn more about [failed refunds](https://docs.stripe.com/refunds#failed-refunds).
transfer_reversalone of multiple schemasThis refers to the transfer reversal object if the accompanying transfer reverses. This is only applicable if the charge was created using the destination parameter.
HTTP default: Error response.
FieldTypeDescription
error requiredapi_errors
GET /v1/charges/{charge}/refunds/{refund}

/v1/charges/{charge}/refunds/{refund}

Retrieves the details of an existing refund.

Request parameters

ParameterLocationTypeDescription
chargepathstring
expandqueryarray of stringSpecifies which fields in the response should be expanded.
refundpathstring

object. See the OpenAPI specification for the complete schema.

Responses

HTTP 200: Successful response.
FieldTypeDescription
amount requiredintegerAmount, in cents (or local equivalent).
balance_transactionone of multiple schemasBalance transaction that describes the impact on your account balance.
chargeone of multiple schemasID of the charge that's refunded.
created requiredintegerTime at which the object was created. Measured in seconds since the Unix epoch.
currency requiredstringThree-letter [ISO currency code](https://www.iso.org/iso-4217-currency-codes.html), in lowercase. Must be a [supported currency](https://stripe.com/docs/currencies).
customerone of multiple schemasID of the customer of this refund.
customer_accountstringID of the account of this refund.
descriptionstringAn arbitrary string attached to the object. You can use this for displaying to users (available on non-card refunds only).
destination_detailsrefund_destination_details
failure_balance_transactionone of multiple schemasAfter the refund fails, this balance transaction describes the adjustment made on your account balance that reverses the initial balance transaction.
failure_reasonstringProvides the reason for the refund failure. Possible values are: `lost_or_stolen_card`, `expired_or_canceled_card`, `charge_for_pending_refund_disputed`, `insufficient_funds`, `declined`, `merchant_request`, or `unknown`.
id requiredstringUnique identifier for the object.
instructions_emailstringFor payment methods without native refund support (for example, Konbini, PromptPay), provide an email address for the customer to receive refund instructions.
metadataobjectSet of [key-value pairs](https://docs.stripe.com/api/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format.
next_actionrefund_next_action
object requiredstringString representing the object's type. Objects of the same type share the same value.
payment_intentone of multiple schemasID of the PaymentIntent that's refunded.
payment_methodone of multiple schemasID of the payment method associated with this refund.
pending_reasonstringProvides the reason for why the refund is pending. Possible values are: `processing`, `insufficient_funds`, or `charge_pending`.
presentment_detailspayment_flows_payment_intent_presentment_details
reasonstringReason for the refund, which is either user-provided (`duplicate`, `fraudulent`, or `requested_by_customer`) or generated by Stripe internally (`expired_uncaptured_charge`).
receipt_numberstringThis is the transaction number that appears on email receipts sent for this refund.
source_transfer_reversalone of multiple schemasThe transfer reversal that's associated with the refund. Only present if the charge came from another Stripe account.
statusstringStatus of the refund. This can be `pending`, `requires_action`, `succeeded`, `failed`, or `canceled`. Learn more about [failed refunds](https://docs.stripe.com/refunds#failed-refunds).
transfer_reversalone of multiple schemasThis refers to the transfer reversal object if the accompanying transfer reverses. This is only applicable if the charge was created using the destination parameter.
HTTP default: Error response.
FieldTypeDescription
error requiredapi_errors
POST /v1/charges/{charge}/refunds/{refund}

/v1/charges/{charge}/refunds/{refund}

Update a specified refund.

Request parameters

ParameterLocationTypeDescription
chargepathstring
refundpathstring
FieldTypeDescription
expandarray of stringSpecifies which fields in the response should be expanded.
metadataone of multiple schemas

Responses

HTTP 200: Successful response.
FieldTypeDescription
amount requiredintegerAmount, in cents (or local equivalent).
balance_transactionone of multiple schemasBalance transaction that describes the impact on your account balance.
chargeone of multiple schemasID of the charge that's refunded.
created requiredintegerTime at which the object was created. Measured in seconds since the Unix epoch.
currency requiredstringThree-letter [ISO currency code](https://www.iso.org/iso-4217-currency-codes.html), in lowercase. Must be a [supported currency](https://stripe.com/docs/currencies).
customerone of multiple schemasID of the customer of this refund.
customer_accountstringID of the account of this refund.
descriptionstringAn arbitrary string attached to the object. You can use this for displaying to users (available on non-card refunds only).
destination_detailsrefund_destination_details
failure_balance_transactionone of multiple schemasAfter the refund fails, this balance transaction describes the adjustment made on your account balance that reverses the initial balance transaction.
failure_reasonstringProvides the reason for the refund failure. Possible values are: `lost_or_stolen_card`, `expired_or_canceled_card`, `charge_for_pending_refund_disputed`, `insufficient_funds`, `declined`, `merchant_request`, or `unknown`.
id requiredstringUnique identifier for the object.
instructions_emailstringFor payment methods without native refund support (for example, Konbini, PromptPay), provide an email address for the customer to receive refund instructions.
metadataobjectSet of [key-value pairs](https://docs.stripe.com/api/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format.
next_actionrefund_next_action
object requiredstringString representing the object's type. Objects of the same type share the same value.
payment_intentone of multiple schemasID of the PaymentIntent that's refunded.
payment_methodone of multiple schemasID of the payment method associated with this refund.
pending_reasonstringProvides the reason for why the refund is pending. Possible values are: `processing`, `insufficient_funds`, or `charge_pending`.
presentment_detailspayment_flows_payment_intent_presentment_details
reasonstringReason for the refund, which is either user-provided (`duplicate`, `fraudulent`, or `requested_by_customer`) or generated by Stripe internally (`expired_uncaptured_charge`).
receipt_numberstringThis is the transaction number that appears on email receipts sent for this refund.
source_transfer_reversalone of multiple schemasThe transfer reversal that's associated with the refund. Only present if the charge came from another Stripe account.
statusstringStatus of the refund. This can be `pending`, `requires_action`, `succeeded`, `failed`, or `canceled`. Learn more about [failed refunds](https://docs.stripe.com/refunds#failed-refunds).
transfer_reversalone of multiple schemasThis refers to the transfer reversal object if the accompanying transfer reverses. This is only applicable if the charge was created using the destination parameter.
HTTP default: Error response.
FieldTypeDescription
error requiredapi_errors